//////////////////////////////////////////////
// ************** WebSocket *************** //
//////////////////////////////////////////////

var websocket;
var dataArray = [];
var min, max;
var xTime = 0;

function wsConnect() {
  
  // start a WebSocket
  websocket = new WebSocket('ws://192.168.1.125:81/');
  // console.log("ws://" + window.location.hostname + ":81/");
    
  websocket.onopen = function(event) { onOpen(event) }
  websocket.onclose = function(event) { onClose(event) }
  websocket.onmessage = function(event) { onMessage(event) }
  websocket.onerror = function(event) { console.log(event.data); }
}

function onOpen(event){
  console.log('websocket opened ' + event.data);
}

function onClose(event){
  console.log('websocket closed ' + event.data);
  wsConnect();
}

function onMessage(event){
  console.log('websocket data: ' + event.data);
  var value = String(event.data);
  value = parseInt(value);
  receivedData(value);
  
  dataArray.push(value);
  
  if (xTime > 100) {
    min = parseInt(Math.min.apply(null, dataArray.filter(function(n) { return !isNaN(n); })));
    max = parseInt(Math.max.apply(null, dataArray.filter(function(n) { return !isNaN(n); })));
    xTime = 0;
    console.log(min, max);
  }
  
  xTime++;
}

//////////////////////////////////////////////
// **************** P5.js ***************** //
//////////////////////////////////////////////

// Wavey Grass
var t = 0; // time variable
var thickness = 10;
var radius = 20;


// Morph
let circle = [];
let square = [];
let morph = [];
let state = false;

function setup() {
  createCanvas(windowWidth, windowHeight);
  noStroke();
  
  // MORPH SETUP
//  // Create a circle using vectors pointing from center
//  for (let angle = 0; angle < 360; angle += 9) {
//    // Note we are not starting from 0 in order to match the
//    // path of a circle.
//    let v = p5.Vector.fromAngle(radians(angle - 135));
//    v.mult(100);
//    circle.push(v);
//    // Let's fill out morph ArrayList with blank PVectors while we are at it
//    morph.push(createVector());
//  }
//
//  // A square is a bunch of vertices along straight lines
//  // Top of square
//  for (let x = -50; x < 50; x += 10) {
//    square.push(createVector(x, -50));
//  }
//  // Right side
//  for (let y = -50; y < 50; y += 10) {
//    square.push(createVector(50, y));
//  }
//  // Bottom
//  for (let x = 50; x > -50; x -= 10) {
//    square.push(createVector(x, 50));
//  }
//  // Left side
//  for (let y = 50; y > -50; y -= 10) {
//    square.push(createVector(-50, y));
//  }
}

function draw() {
    
  // WAVEY GRASS
  background(10, 20, 0, 10); // translucent background (creates trails)

  // make a x and y grid of ellipses
  for (let x = 0; x <= width; x = x + 30) {
    for (let y = 0; y <= height; y = y + 30) {
      
      // starting point of each circle depends on mouse position
      const xAngle = map(mouseX, 0, width, -4 * PI, 4 * PI, true);
      const yAngle = map(mouseY, 0, height, -4 * PI, 4 * PI, true);
      // and also varies based on the particle's location
      const angle = xAngle * (x / width) + yAngle * (y / height);

      // each particle moves in a circle
      const myX = x + radius * cos(2 * PI * t + angle);
      const myY = y + radius * sin(2 * PI * t + angle);
      fill(73,252,213);
      noStroke();
      ellipse(myX, myY, thickness); // draw particle
    }
  }

  t = t + 0.01; // update time
  
  
//  // MORPHING CUBE
//  // We will keep how far the vertices are from their target
//  let totalDistance = 0;
//
//  // Look at each vertex
//  for (let i = 0; i < circle.length; i++) {
//    let v1;
//    // Are we lerping to the circle or square?
//    if (state) {
//      v1 = circle[i];
//    } else {
//      v1 = square[i];
//    }
//    // Get the vertex we will draw
//    let v2 = morph[i];
//    // Lerp to the target
//    v2.lerp(v1, 0.1);
//    // Check how far we are from target
//    totalDistance += p5.Vector.dist(v1, v2);
//  }
//
//  // If all the vertices are close, switch shape
////  if (totalDistance < 0.1) {
////    state = !state;
////  }
//
//  // Draw relative to center
//  translate(width / 2, height / 2);
//  strokeWeight(4);
//  
//  // Draw a polygon that makes up all the vertices
//  beginShape();
//  noFill();
//  stroke(255);
//
//  morph.forEach(v => {
//    vertex(v.x, v.y);
//  });
//  endShape(CLOSE);
}

function mousePressed() {
  if (state = true) {
    websocket.send("off");
  } else {
    websocket.send("on");
  }
  
  state = !state;
}

function receivedData(value) {
  value = map(value, min, max, 0, 30);
  thickness = value;
}